searchNodes=[{"doc":"Formats and rewrites the given files and patterns. mix style mix.exs &quot;lib/ /*.{ex,exs}&quot; &quot;test/ /*.{ex,exs}&quot; If - is one of the files, input is read from stdin and written to stdout. mix style uses the same options as mix format specified in .formatter.exs to format the code, and to determine which files to style if you don't pass any as arguments Task-specific options --check-formatted - an alias for --check-styled , included for compatibility with mix format --check-styled - checks that the file is already styled rather than styling it. useful for CI.","ref":"Mix.Tasks.Style.html","title":"Mix.Tasks.Style","type":"task"},{"doc":"Styler is a formatter plugin with stronger opinions on code organization, multi-line defs and other code-style matters.","ref":"Styler.html","title":"Styler","type":"module"},{"doc":"A Style takes AST and returns a transformed version of that AST. Because these transformations involve traversing trees (the &quot;T&quot; in &quot;AST&quot;), we wrap the AST in a structure called a Zipper to facilitate walking the trees.","ref":"Styler.Style.html","title":"Styler.Style","type":"behaviour"},{"doc":"Set the line of all comments with line in range_start..range_end to instead have line range_start","ref":"Styler.Style.html#displace_comments/2","title":"Styler.Style.displace_comments/2","type":"function"},{"doc":"Returns true if the ast represents an empty map","ref":"Styler.Style.html#empty_map?/1","title":"Styler.Style.empty_map?/1","type":"function"},{"doc":"Ensure the parent node can have multiple children. If a context-changing node (a do end block or an -&gt; arrow block) is encountered the child is wrapped in a :__block__ Other nodes (pipes, assignments) can only have a fixed number of children. This function will recursively traverse up the zipper until it's found the parents of those nodes.","ref":"Styler.Style.html#ensure_block_parent/1","title":"Styler.Style.ensure_block_parent/1","type":"function"},{"doc":"run will be used with Zipper.traverse_while/3 , meaning it will be executed on every node of the AST. You can skip traversing parts of the tree by returning a Zipper that's further along in the traversal, for example by calling Zipper.skip(zipper) to skip an entire subtree you know is of no interest to your Style.","ref":"Styler.Style.html#c:run/2","title":"Styler.Style.run/2","type":"callback"},{"doc":"Sets :line , :closing , and :last to all be on line and deletes :newlines","ref":"Styler.Style.html#set_line/2","title":"Styler.Style.set_line/2","type":"function"},{"doc":"Change the line of all comments with line in range by adding delta to it. A positive delta will move the lines further down a file, while a negative delta will move them up.","ref":"Styler.Style.html#shift_comments/3","title":"Styler.Style.shift_comments/3","type":"function"},{"doc":"Traverses an ast node, updating all nodes' meta with meta_fun","ref":"Styler.Style.html#update_all_meta/2","title":"Styler.Style.update_all_meta/2","type":"function"},{"doc":"","ref":"Styler.Style.html#t:context/0","title":"Styler.Style.context/0","type":"type"},{"doc":"Styles function heads so that they're as small as possible. The goal is that a function head fits on a single line. This isn't a Credo issue, and the formatter is fine with either approach. But Styler has opinions! Ex: This long declaration def foo ( %{ bar : baz } ) do ... end Becomes def foo ( %{ bar : baz } ) do ... end","ref":"Styler.Style.Defs.html","title":"Styler.Style.Defs","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.Defs.html#run/2","title":"Styler.Style.Defs.run/2","type":"function"},{"doc":"Styles up module directives! This Style will expand multi-aliases/requires/imports/use and sort the directive within its groups (except use s, which cannot be sorted) It also adds a blank line after each directive group. Credo rules Rewrites for the following Credo rules: Credo.Check.Consistency.MultiAliasImportRequireUse (force expansion) Credo.Check.Readability.AliasOrder (we sort __MODULE__ , which credo doesn't) Credo.Check.Readability.ModuleDoc (adds @moduledoc false if missing. includes *.exs files) Credo.Check.Readability.MultiAlias Credo.Check.Readability.StrictModuleLayout (see section below for details) Credo.Check.Readability.UnnecessaryAliasExpansion Strict Layout This can break your code. Modules directives are sorted into the following order: @shortdoc @moduledoc @behaviour use import alias require everything else (unchanged) If any of the sorted directives had a dependency on code that is now below it, your code will fail to compile after being styled. For instance, the following will be broken because the module attribute definition will be moved below the use clause, meaning @pi is undefined when invoked. # before defmodule Approximation do @pi 3.14 use Math , pi : @pi end # after defmodule Approximation do @moduledoc false use Math , pi : @pi @pi 3.14 end For now, it's up to you to come up with a fix for this issue. Sorry!","ref":"Styler.Style.ModuleDirectives.html","title":"Styler.Style.ModuleDirectives","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.ModuleDirectives.html#run/2","title":"Styler.Style.ModuleDirectives.run/2","type":"function"},{"doc":"Styles pipes! In particular, don't make pipe chains of only one pipe, and some persnickety pipe chain start stuff. Rewrites for the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.OneArityFunctionInPipe Credo.Check.Readability.PipeIntoAnonymousFunctions Credo.Check.Readability.SinglePipe Credo.Check.Refactor.FilterCount Credo.Check.Refactor.MapInto Credo.Check.Refactor.MapJoin Credo.Check.Refactor.PipeChainStart, excluded_functions: [&quot;from&quot;]","ref":"Styler.Style.Pipes.html","title":"Styler.Style.Pipes","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.Pipes.html#run/2","title":"Styler.Style.Pipes.run/2","type":"function"},{"doc":"Simple 1-1 rewrites all crammed into one module to make for more efficient traversals Credo Rules addressed: Credo.Check.Consistency.ParameterPatternMatching Credo.Check.Readability.LargeNumbers Credo.Check.Readability.ParenthesesOnZeroArityDefs Credo.Check.Readability.PreferImplicitTry Credo.Check.Readability.WithSingleClause Credo.Check.Refactor.CaseTrivialMatches Credo.Check.Refactor.CondStatements Credo.Check.Refactor.RedundantWithClauseResult Credo.Check.Refactor.WithClauses","ref":"Styler.Style.SingleNode.html","title":"Styler.Style.SingleNode","type":"module"},{"doc":"Callback implementation for Styler.Style.run/2 .","ref":"Styler.Style.SingleNode.html#run/2","title":"Styler.Style.SingleNode.run/2","type":"function"},{"doc":"Implements a Zipper for the Elixir AST based on Gérard Huet Functional pearl: the zipper paper and Clojure's clojure.zip API. A zipper is a data structure that represents a location in a tree from the perspective of the current node, also called focus . It is represented by a 2-tuple where the first element is the focus and the second element is the metadata/context. The metadata is nil when the focus is the topmost node","ref":"Styler.Zipper.html","title":"Styler.Zipper","type":"module"},{"doc":"Inserts the item as the rightmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#append_child/2","title":"Styler.Zipper.append_child/2","type":"function"},{"doc":"Returns a list of children of the node.","ref":"Styler.Zipper.html#children/1","title":"Styler.Zipper.children/1","type":"function"},{"doc":"Returns the zipper of the leftmost child of the node at this zipper, or nil if no there's no children.","ref":"Styler.Zipper.html#down/1","title":"Styler.Zipper.down/1","type":"function"},{"doc":"Returns a zipper to the node that satisfies the predicate function, or nil if none is found. The optional second parameters specifies the direction , defaults to :next .","ref":"Styler.Zipper.html#find/3","title":"Styler.Zipper.find/3","type":"function"},{"doc":"Inserts the item as the leftmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#insert_child/2","title":"Styler.Zipper.insert_child/2","type":"function"},{"doc":"Inserts the item as the left sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_left/2","title":"Styler.Zipper.insert_left/2","type":"function"},{"doc":"Inserts the item as the right sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_right/2","title":"Styler.Zipper.insert_right/2","type":"function"},{"doc":"Returns the zipper of the left sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#left/1","title":"Styler.Zipper.left/1","type":"function"},{"doc":"Returns the leftmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#leftmost/1","title":"Styler.Zipper.leftmost/1","type":"function"},{"doc":"Returns the following zipper in depth-first pre-order.","ref":"Styler.Zipper.html#next/1","title":"Styler.Zipper.next/1","type":"function"},{"doc":"Returns the node at the zipper.","ref":"Styler.Zipper.html#node/1","title":"Styler.Zipper.node/1","type":"function"},{"doc":"Returns the previous zipper in depth-first pre-order. If it's already at the end, it returns nil.","ref":"Styler.Zipper.html#prev/1","title":"Styler.Zipper.prev/1","type":"function"},{"doc":"Removes the node at the zipper, returning the zipper that would have preceded it in a depth-first walk.","ref":"Styler.Zipper.html#remove/1","title":"Styler.Zipper.remove/1","type":"function"},{"doc":"Replaces the current node in the zipper with a new node.","ref":"Styler.Zipper.html#replace/2","title":"Styler.Zipper.replace/2","type":"function"},{"doc":"Returns a new node, given an existing node and new children.","ref":"Styler.Zipper.html#replace_children/2","title":"Styler.Zipper.replace_children/2","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#right/1","title":"Styler.Zipper.right/1","type":"function"},{"doc":"Returns the rightmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#rightmost/1","title":"Styler.Zipper.rightmost/1","type":"function"},{"doc":"Walks the zipper all the way up and returns the root node.","ref":"Styler.Zipper.html#root/1","title":"Styler.Zipper.root/1","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or the next zipper when no right sibling is available. This allows to skip subtrees while traversing the siblings of a node. The optional second parameters specifies the direction , defaults to :next . If no right/left sibling is available, this function returns the same value as next/1 / prev/1 . The function skip/1 behaves like the :skip in traverse_while/2 and traverse_while/3 .","ref":"Styler.Zipper.html#skip/2","title":"Styler.Zipper.skip/2","type":"function"},{"doc":"Walks the zipper all the way up and returns the top zipper.","ref":"Styler.Zipper.html#top/1","title":"Styler.Zipper.top/1","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse/2","title":"Styler.Zipper.traverse/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse/3","title":"Styler.Zipper.traverse/3","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. The traversing will continue if the function returns {:cont, zipper} , skipped for {:skip, zipper} and halted for {:halt, zipper} If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse_while/2","title":"Styler.Zipper.traverse_while/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. The traversing will continue if the function returns {:cont, zipper, acc} , skipped for {:skip, zipper, acc} and halted for {:halt, zipper, acc} If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse_while/3","title":"Styler.Zipper.traverse_while/3","type":"function"},{"doc":"Returns the zipper of the parent of the node at this zipper, or nil if at the top.","ref":"Styler.Zipper.html#up/1","title":"Styler.Zipper.up/1","type":"function"},{"doc":"Replaces the current node in the zipper with the result of applying fun to the node.","ref":"Styler.Zipper.html#update/2","title":"Styler.Zipper.update/2","type":"function"},{"doc":"Creates a zipper from a tree node.","ref":"Styler.Zipper.html#zip/1","title":"Styler.Zipper.zip/1","type":"function"},{"doc":"","ref":"Styler.Zipper.html#t:command/0","title":"Styler.Zipper.command/0","type":"type"},{"doc":"","ref":"Styler.Zipper.html#t:path/0","title":"Styler.Zipper.path/0","type":"opaque"},{"doc":"","ref":"Styler.Zipper.html#t:tree/0","title":"Styler.Zipper.tree/0","type":"type"},{"doc":"","ref":"Styler.Zipper.html#t:zipper/0","title":"Styler.Zipper.zipper/0","type":"type"},{"doc":"Wraps errors raised by Styles during tree traversal.","ref":"Styler.StyleError.html","title":"Styler.StyleError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Styler.StyleError.html#message/1","title":"Styler.StyleError.message/1","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#main","title":"Changelog - main","type":"extras"},{"doc":"Fixes fix mistaking Timex.now/1 in a pipe for Timex.now/0 (#66, h/t @sabiwara) Removed style stop rewriting Timex.today/0 given that we allow Timex.today/1 -- too inconsistent.","ref":"changelog.html#v0-9-5","title":"Changelog - v0.9.5","type":"extras"},{"doc":"Improvements if statements: drop else clauses whose body is simply nil","ref":"changelog.html#v0-9-4","title":"Changelog - v0.9.4","type":"extras"},{"doc":"Fixes fix unless a do b else c end rewrites to if not flopping do/else bodies! (#77, h/t @jcowgar) fix pipes styling ranges with steps ( a..b//c ) incorrectly (#76, h/t @cschmatzler)","ref":"changelog.html#v0-9-3","title":"Changelog - v0.9.3","type":"extras"},{"doc":"Fixes fix exception styling module attributes named @def (we confused them with real def s, whoops!) (#75, h/t @randycoulman)","ref":"changelog.html#v0-9-2","title":"Changelog - v0.9.2","type":"extras"},{"doc":"the boolean blocks edition! Improvements auto-fix Credo.Check.Refactor.CondStatements (detects any truthy atom, not just true ) if/unless rewrites: Credo.Check.Refactor.NegatedConditionsWithElse Credo.Check.Refactor.NegatedConditionsInUnless Credo.Check.Refactor.UnlessWithElse","ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras"},{"doc":"the with statement edition! Improvements Added right-hand-pattern-matching rewrites to for and with left arrow expressions &lt;- (ex: with map = %{} &lt;- foo() =&gt; with %{} = map &lt;- foo ) with statement rewrites, solving the following credo rules Credo.Check.Readability.WithSingleClause Credo.Check.Refactor.RedundantWithClauseResult Credo.Check.Refactor.WithClauses","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"Fixes Fixed exception when encountering non-arrowed case statements ala case foo, do: unquote(quoted) (#69, h/t @brettinternet, nice)","ref":"changelog.html#v0-8-5","title":"Changelog - v0.8.5","type":"extras"},{"doc":"Fixes Timex related fixes (#66): Rewrite Timex.now/1 to DateTime.now!/1 instead of DateTime.utc_now/1 Only rewrite Timex.today/0 , don't change Timex.today/1","ref":"changelog.html#v0-8-4","title":"Changelog - v0.8.4","type":"extras"},{"doc":"Improvements DateTime rewrites (#62, ht @milmazz) DateTime.compare =&gt; DateTime.{before/after} (elixir &gt;= 1.15) Timex.now =&gt; DateTime.utc_now Timex.today =&gt; Date.utc_today Fixes Pipes: add != , !== , === , and , and or to list of valid infix operators (#64)","ref":"changelog.html#v0-8-3","title":"Changelog - v0.8.3","type":"extras"},{"doc":"Fixes Pipes always de-sugars keyword lists when unpiping them (#60)","ref":"changelog.html#v0-8-2","title":"Changelog - v0.8.2","type":"extras"},{"doc":"Fixes ModuleDirectives doesn't mistake variables for directives (#57, h/t @leandrocp)","ref":"changelog.html#v0-8-1","title":"Changelog - v0.8.1","type":"extras"},{"doc":"Improvements (Bug Fix!?) ModuleDirectives no longer throws comments around a file when hoisting directives up (#53)","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Improvements rewrite Logger.warn/1,2 to Logger.warning/1,2 due to Elixir 1.15 deprecation","ref":"changelog.html#v0-7-14","title":"Changelog - v0.7.14","type":"extras"},{"doc":"Fixes don't unpipe single-piped unquote expressions (h/t @elliottneilclark)","ref":"changelog.html#v0-7-13","title":"Changelog - v0.7.13","type":"extras"},{"doc":"Fixes fix 0-arity paren removal on metaprogramming creating uncompilable code (h/t @simonprev)","ref":"changelog.html#v0-7-12","title":"Changelog - v0.7.12","type":"extras"},{"doc":"Fixes fix crash from mix style running plugins as part of formatting (no longer runs formatter plugins) Improvements single-quote charlists are rewritten to use the ~c sigil ( 'foo' -&gt; ~c'foo' ) (h/t @fhunleth) mix style warns the user that Styler is primarily meant to be used as a plugin","ref":"changelog.html#v0-7-11","title":"Changelog - v0.7.11","type":"extras"},{"doc":"Fixes fix crash when encountering single-quote charlists (h/t @fhunleth) Improvements single-quote charlists are rewritten to use the ~c sigil ( 'foo' -&gt; ~c'foo' ) when encountering _ = bar -&gt; , replace it with bar -&gt;","ref":"changelog.html#v0-7-10","title":"Changelog - v0.7.10","type":"extras"},{"doc":"Fixes Fix a toggle state resulting from (ahem, nonsense) code like _ = bar -&gt; encountering ParameterPatternMatching style","ref":"changelog.html#v0-7-9","title":"Changelog - v0.7.9","type":"extras"},{"doc":"Fixes Fix crash trying to remove 0-arity parens from metaprogramming ala def unquote(foo)()","ref":"changelog.html#v0-7-8","title":"Changelog - v0.7.8","type":"extras"},{"doc":"Improvements Rewrite Enum.into/2,3 into Map.new/1,2 when the collectable is %{} or Map.new/0","ref":"changelog.html#v0-7-7","title":"Changelog - v0.7.7","type":"extras"},{"doc":"Fixes Fix crash when single pipe had inner defs (h/t @michallepicki )","ref":"changelog.html#v0-7-6","title":"Changelog - v0.7.6","type":"extras"},{"doc":"Fixes Fix bug from ParameterPatternMatching implementation that re-ordered pattern matching in cond do -&gt; clauses","ref":"changelog.html#v0-7-5","title":"Changelog - v0.7.5","type":"extras"},{"doc":"Features Implement Credo.Check.Readability.PreferImplicitTry Implement Credo.Check.Consistency.ParameterPatternMatching for def|defp|fn|case","ref":"changelog.html#v0-7-4","title":"Changelog - v0.7.4","type":"extras"},{"doc":"Features Remove parens from 0-arity function definitions ( Credo.Check.Readability.ParenthesesOnZeroArityDefs )","ref":"changelog.html#v0-7-3","title":"Changelog - v0.7.3","type":"extras"},{"doc":"Features Rewrite case ... true -&gt; ...; _ -&gt; ... to if statements as well","ref":"changelog.html#v0-7-2","title":"Changelog - v0.7.2","type":"extras"},{"doc":"Features Rewrite case ... true / else -&gt; to be if statements","ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras"},{"doc":"Features Styler.Style.Simple : Optimize Enum.reverse(foo) ++ bar to Enum.reverse(foo, bar) Styler.Style.Pipes : Rewrite |&gt; (&amp; ...).() to |&gt; then(&amp; ...) ( Credo.Check.Readability.PipeIntoAnonymousFunctions ) Add parens to 1-arity pipe functions ( Credo.Check.Readability.OneArityFunctionInPipe ) Optimize a |&gt; Enum.reverse() |&gt; Enum.concat(enum) to Enum.reverse(a, enum)","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Improvements Better error handling: mix format will still format files if a style fails Fixes mix style : only run on .ex and .exs files ModuleDirectives : now expands alias __MODULE__.{A, B} (h/t @adriankumpf )","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"Features mix style : brought back to life for folks who want to incrementally introduce Styler Fixes Styler.Style.Pipes : include x in y and ^foo (for ecto) as a valid pipe starts work even harder to keep rewrites on one line","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Fixes ModuleDirectives : handle dynamic module names Pipes : include Ecto.Query.from and Query.from as valid pipe starts","ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","type":"extras"},{"doc":"Improvements Sped up styling just a little bit","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Improvements Styler now implements Mix.Task.Format , meaning it is now an Elixir formatter plugin. See the README for new installation &amp; usage instructions Breaking Change! Wooo! the mix style task has been removed","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Improvements Pipes rewrites |&gt; Enum.into(%{}[, mapper]) and Enum.into(Map.new()[, mapper]) to Map.new/1,2 calls","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Improvements Pipes rewrites some two-step processes into one, fixing these credo issues in pipe chains: Credo.Check.Refactor.FilterCount Credo.Check.Refactor.MapJoin Credo.Check.Refactor.MapInto Fixes ModuleDirectives handles even weirder places to hide your aliases (anonymous functions, in this case) Pipes tries even harder to keep single-pipe rewrites of invocations on one line","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Fixes Pipes fixed omission of == as a valid pipe start operator (h/t @peake100 for the issue) fixed rewrite of a |&gt; b , where b was invoked without parenthesis","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Improvements Enabled Defs style and overhauled it to properly handles comments Optimized and tweaked ModuleDirectives style Now culls newlines between &quot;groups&quot; of the same directive sorts @behaviour directives orders directives within non defmodule contexts (eg, a def do ) if there's at least one alias|require|use|import Fixes Pipes will try to keep single-pipe rewrites on one line","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Improvements Added ModuleDirectives style Note that this is potentially destructive in some rare cases. See moduledoc for more. This supersedes the Aliases style, which has been removed. mix style - reads and writes to stdin/stdout Fixes Pipes style is now aware of unless blocks","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Improvements Lots of README tweaking =) Optimized some Zipper operations Added Simple style, replacing the following Credo rule: Credo.Check.Readability.LargeNumbers Fixes Exceptions while parsing code now appropriately render filename rather than nofile:xx Fixed opaque Zipper.path() typespec implementation mismatches (thanks @sega-yarkin) Made ex_doc dev only, removing it as a dependency for users of Styler","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Improvements Initial release of Styler Added Aliases style, replacing the following Credo rules: Credo.Check.Readability.AliasOrder Credo.Check.Readability.MultiAlias Credo.Check.Readability.UnnecessaryAliasExpansion Added Pipes style, replacing the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.SinglePipe Credo.Check.Refactor.PipeChainStart Added Defs style (currently disabled by default)","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"Styler is an Elixir formatter plugin that's combination of mix format and mix credo , except instead of telling you what's wrong, it just rewrites the code for you to fit its style rules. You can learn more about the history, purpose and implementation of Styler from our talk: Styler: Elixir Style-Guide Enforcer @ GigCity Elixir 2023","ref":"readme.html","title":"Styler","type":"extras"},{"doc":"Add :styler as a dependency to your project's mix.exs : def deps do [ { :styler , &quot;~&gt; 0.9&quot; , only : [ :dev , :test ] , runtime : false } , ] end Then add Styler as a plugin to your .formatter.exs file [ plugins : [ Styler ] ] And that's it! Now when you run mix format you'll also get the benefits of Styler's definitely-always-right style fixes. Configuration There isn't any! This is intentional. Styler is @adobe's internal Style Guide Enforcer - allowing exceptions to the styles goes against that ethos. Happily, it's open source and thus yours to do with as you will =)","ref":"readme.html#installation","title":"Styler - Installation","type":"extras"},{"doc":"At this point, Styler does a lot. We've catalogued a list of Credo rules that it automatically fixes, but it does some things - like shrinking function heads down to a single line when possible - that Credo doesn't care about. Ultimately, the best way to see what Styler does is to just try it out! What could go wrong? (You're using version control, right?) Credo Rules Styler Replaces If you're using Credo and Styler, we recommend disabling these rules in .credo.exs to save on unnecessary checks in CI. Disabling the rules means updating your .credo.exs depending on your configuration: if you're using checks: %{enabled: [...]} , ensure none of the checks are listed in your enabled checks if you're using checks: %{disabled: [...]} , copy/paste the snippet below into the list if you're using checks: [...] , copy/paste the snippet below into the list and ensure none of the checks appear earlier in the list # Styler Rewrites # # The following rules are automatically rewritten by Styler and so disabled here to save time # Some of the rules have `priority: :high`, meaning Credo runs them unless we explicitly disable them # (removing them from this file wouldn&#39;t be enough, the `false` is required) # # Some rules have a comment before them explaining ways Styler deviates from the Credo rule. # # always expands `A.{B, C}` { Credo.Check.Consistency.MultiAliasImportRequireUse , false } , # including `case`, `fn` and `with` statements { Credo.Check.Consistency.ParameterPatternMatching , false } , { Credo.Check.Readability.AliasOrder , false } , { Credo.Check.Readability.BlockPipe , false } , # goes further than formatter - fixes bad underscores, eg: `100_00` -&gt; `10_000` { Credo.Check.Readability.LargeNumbers , false } , # adds `@moduledoc false` { Credo.Check.Readability.ModuleDoc , false } , { Credo.Check.Readability.MultiAlias , false } , { Credo.Check.Readability.OneArityFunctionInPipe , false } , # removes parens { Credo.Check.Readability.ParenthesesOnZeroArityDefs , false } , { Credo.Check.Readability.PipeIntoAnonymousFunctions , false } , { Credo.Check.Readability.PreferImplicitTry , false } , { Credo.Check.Readability.SinglePipe , false } , # **potentially breaks compilation** - see **Troubleshooting** section below { Credo.Check.Readability.StrictModuleLayout , false } , { Credo.Check.Readability.UnnecessaryAliasExpansion , false } , { Credo.Check.Readability.WithSingleClause , false } , { Credo.Check.Refactor.CaseTrivialMatches , false } , { Credo.Check.Refactor.CondStatements , false } , # in pipes only { Credo.Check.Refactor.FilterCount , false } , # in pipes only { Credo.Check.Refactor.MapInto , false } , # in pipes only { Credo.Check.Refactor.MapJoin , false } , { Credo.Check.Refactor.NegatedConditionsInUnless , false } , { Credo.Check.Refactor.NegatedConditionsWithElse , false } , # allows ecto&#39;s `from { Credo.Check.Refactor.PipeChainStart , false } , { Credo.Check.Refactor.RedundantWithClauseResult , false } , { Credo.Check.Refactor.UnlessWithElse , false } , { Credo.Check.Refactor.WithClauses , false } ,","ref":"readme.html#features-or-as-we-call-them-styles","title":"Styler - Features (or as we call them, &quot;Styles&quot;)","type":"extras"},{"doc":"Speed : Expect the first run to take some time as Styler rewrites violations of styles. Once styled the first time, future styling formats shouldn't take noticeably more time. Troubleshooting: Compilation broke due to Module Directive rearrangement Sometimes naively moving Module Directives around can break compilation. Here's helpers on how to manually fix that and have a happy styling for the rest of your codebase's life. Alias dependency If you have an alias that, for example, a @behaviour relies on, compilation will break after your first run. This requires one-time manual fixing to get your repo in line with Styler's standards. For example, if your code was this: defmodule MyModule do @moduledoc &quot;Implements MyBehaviour!&quot; alias Deeply.Nested.MyBehaviour @behaviour MyBehaviour ... end then Styler will style the file like this, which cannot compile due to MyBehaviour not being defined. defmodule MyModule do @moduledoc &quot;Implements MyBehaviour!&quot; @behaviour MyBehaviour # &lt;------ compilation error, MyBehaviour is not defined! alias Deeply.Nested.MyBehaviour ... end A simple solution is to manually expand the alias with a find-replace-all like: @behaviour MyBehaviour -&gt; @behaviour Deeply.Nested.MyBehaviour . It's important to specify that you only want to find-replace with the @behaviour prefix or you'll unintentially expand MyBehaviour everywhere in the codebase. Module Attribute dependency Another common compilation break on the first run is a @moduledoc that depended on another module attribute which was moved below it. For example, given the following broken code after an initial mix format : defmodule MyGreatLibrary do @moduledoc make_pretty_docs ( @library_options ) @library_options [ ... ] end You can fix the code by moving the static value outside of the module into a naked variable and then reference it in the module. Yes, this is a thing you can do in a .ex file =) library_options = [ ... ] defmodule MyGreatLibrary do @moduledoc make_pretty_docs ( library_options ) @library_options library_options end","ref":"readme.html#your-first-styling","title":"Styler - Your first Styling","type":"extras"},{"doc":"Sourceror This work was inspired by earlier large-scale rewrites of an internal codebase that used the fantastic tool Sourceror . The initial implementation of Styler used Sourceror, but Sourceror's AST-embedding comment algorithm slows Styler down to the point that it's no longer an appropriate drop-in for mix format . Still, we're grateful for the inspiration Sourceror provided and the changes to the Elixir AST APIs that it drove. The AST-Zipper implementation in this project was forked from Sourceror's implementation. Credo Similarly, this project originated from one-off scripts doing large scale rewrites of an enormous codebase as part of an effort to enable particular Credo rules for that codebase. Credo's tests and implementations were referenced for implementing Styles that took the work the rest of the way. Thanks to Credo &amp; the Elixir community at large for coalescing around many of these Elixir style credos.","ref":"readme.html#thanks-inspiration","title":"Styler - Thanks &amp; Inspiration","type":"extras"}]